//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "MainFile.h"
#include "Param.h"
#include "AddPoint.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
  TimeLabel->Caption=FloatToStr(t);
  sigma=1;
  dt=1;
  t=0;
  draw_grid();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AddPointButtonClick(TObject *Sender)
{
  AddPointForm->ShowModal();
  if(!x.empty()) {plot(false);}
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::PointBoxChange(TObject *Sender)
{
  update_label();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DelButtonClick(TObject *Sender)
{
  if(!m.empty()) {
   int temp=PointBox->ItemIndex;
   if(temp!=-1) {
    plot(true);
    PointBox->Items->Delete(temp);
    vector<float>::iterator where;
    where=find(x.begin(),x.end(),x[temp]);
    x.erase(where);
    where=find(y.begin(),y.end(),y[temp]);
    y.erase(where);
    where=find(m.begin(),m.end(),m[temp]);
    m.erase(where);
    where=find(V.begin(),V.end(),V[temp]);
    V.erase(where);
    where=find(alpha.begin(),alpha.end(),alpha[temp]);
    alpha.erase(where);
    XLabel->Caption="";
    YLabel->Caption="";
    VLabel->Caption="";
    MLabel->Caption="";
    ALabel->Caption="";
    if(!x.empty()) {plot(false);}
    if(temp!=0) {
     PointBox->ItemIndex=temp-1;
     }
    else {
     PointBox->ItemIndex=0;
     }
    if(!x.empty()) {update_label();}
   }
  }
}
//---------------------------------------------------------------------------
void TMainForm::next_turn()
{
  plot(true);
  int i,j,q=m.size();
  float a,Fx,Fy,F,beta,Vy,Vx;
  for(i=0;i<q;i++) {
   Fx=0;
   Fy=0;
   for(j=0;j<q;j++) {
    if(i!=j) {
     Fx+=cos(ArcTan2(y[j]-y[i],x[j]-x[i]))*m[j]/sqrt(pow(x[j]-x[i],2)+pow(y[j]-y[i],2));
     Fy+=sin(ArcTan2(y[j]-y[i],x[j]-x[i]))*m[j]/sqrt(pow(x[j]-x[i],2)+pow(y[j]-y[i],2));
    }
   }
   Fx*=sigma*m[i];
   Fy*=sigma*m[i];
   F=hypot(Fy,Fx);
   a=F/m[i];
   beta=ArcTan2(Fy,Fx);
   Vx=a*cos(beta)*dt+V[i]*cos(alpha[i]);
   Vy=a*sin(beta)*dt+V[i]*sin(alpha[i]);
   V_next.push_back(hypot(Vx,Vy));
   alpha_next.push_back(ArcTan2(Vy,Vx));
   x_next.push_back(x[i]+V[i]*cos(alpha[i])*dt+a*cos(beta)*pow(dt,2)/2);
   y_next.push_back(y[i]+V[i]*sin(alpha[i])*dt+a*sin(beta)*pow(dt,2)/2);
  }
  for(i=0;i<q;i++) {
   x[i]=x_next[i];
   y[i]=y_next[i];
   V[i]=V_next[i];
   alpha[i]=alpha_next[i];
  }
  t+=dt;
  x_next.clear();
  y_next.clear();
  V_next.clear();
  alpha_next.clear();
  plot(false);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::NextStepButtonClick(TObject *Sender)
{
  if(!m.empty()) {
   next_turn();
   if(PointBox->ItemIndex!=-1) {
    update_label();
    }
   else {
     TimeLabel->Caption=FloatToStr(t);
    }
  }
}
//---------------------------------------------------------------------------
void TMainForm::update_label()
{
  XLabel->Caption=FloatToStr(x[PointBox->ItemIndex]);
  YLabel->Caption=FloatToStr(y[PointBox->ItemIndex]);
  MLabel->Caption=FloatToStr(m[PointBox->ItemIndex]);
  VLabel->Caption=FloatToStr(V[PointBox->ItemIndex]);
  ALabel->Caption=FloatToStr(180*alpha[PointBox->ItemIndex]/M_PI);
  TimeLabel->Caption=FloatToStr(t);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MultiStepButtonClick(TObject *Sender)
{
  try {
   if(!m.empty()) {
    int q=StrToInt(StepNumber->Text),i;
    Progress->Max=q;
    Progress->Position=0;
    for(i=0;i<q;i++) {
     next_turn();
     Progress->Position++;
     TimeLabel->Caption=FloatToStr(t);
    }
   if(PointBox->ItemIndex!=-1) {
    update_label();
    }
   else {
    TimeLabel->Caption=FloatToStr(t);
    }
   }
  }
  catch (EConvertError &exception)
  {
   Application->MessageBox("  ","",
                            MB_OK);
  }
}
//---------------------------------------------------------------------------
void TMainForm::draw_grid()
{
  int height,width,i;
  height=150;
  width=150;
  Image1->Canvas->MoveTo(0,height);
  Image1->Canvas->LineTo(2*width,height);
  Image1->Canvas->MoveTo(width,0);
  Image1->Canvas->LineTo(width,2*height);
  Image1->Canvas->MoveTo(width,-1);
  Image1->Canvas->LineTo(width*29/30,height/15);
  Image1->Canvas->MoveTo(width,-1);
  Image1->Canvas->LineTo(width*31/30,height/15);
  Image1->Canvas->MoveTo(2*width+1,height);
  Image1->Canvas->LineTo(2*width*29/30,height*29/30);
  Image1->Canvas->MoveTo(2*width+1,height);
  Image1->Canvas->LineTo(2*width*29/30,height*31/30);
}
//---------------------------------------------------------------------------
int TMainForm::find_max()
{
  int q=m.size(),i,i1=-1;
  float max1=0;
  for(i=0;i<q;i++) {
   if(fabs(x[i])>max1) {
    max1=fabs(x[i]);
    i1=i;
    }
   if(fabs(y[i])>max1) {
    max1=fabs(y[i]);
    i1=i;
    }
   }
  return(i1);
}
//------------------------------------------------------------------------
void TMainForm::plot(bool clean)
{
  Image1->Canvas->Pen->Color=clBlack;
  draw_grid();
  unsigned int imax=find_max(),i;
  float max,y1,x1;
  if(imax!=-1) {
   max=(fabs(x[imax])>fabs(y[imax]))?fabs(x[imax]):fabs(y[imax]);
   }
  else {
   max=1;
   }
  if(!clean) {
   for(i=0;i<x.size();i++) {
    x1=150+135*x[i]/max;
    y1=150-135*y[i]/max;
    Image1->Canvas->Ellipse(x1-1,y1-1,x1+1,y1+1);
    }
   }
  else {
   Image1->Canvas->CopyMode=cmWhiteness;
   Image1->Canvas->CopyRect(Rect(0,0,Image1->Width,Image1->Height),Image1->Canvas,
                            Rect(0,0,Image1->Width,Image1->Height));
   draw_grid();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ParamButtonClick(TObject *Sender)
{
  ParamForm->ShowModal();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ClearButtonClick(TObject *Sender)
{
  if(!x.empty()) {plot(true);}
  x.clear();
  y.clear();
  V.clear();
  alpha.clear();
  m.clear();
  t=0;
  n=0;
  PointBox->Items->Clear();
  TimeLabel->Caption=FloatToStr(t);
  XLabel->Caption="";
  YLabel->Caption="";
  VLabel->Caption="";
  MLabel->Caption="";
  ALabel->Caption="";
}
//---------------------------------------------------------------------------

